  CSSClass "input.blueButton", "{Background-Color: blue;}"
  CSSClass "input.redButton", "{Background-Color: red;}"
  CSSClass "input.greenButton", "{Background-Color: green;}"
  CSSClass "input.yellowButton", "{Background-Color: yellow;}"
  CSSClass "input.lightgrayButton", "{Background-Color: lightgray;}"
  CSSClass "input.purpleButton", "{Background-Color: purple;}"
  CSSClass "input.orangeButton", "{Background-Color: orange;}"

  Period=0 ' Hour
  Period$="hour" ' hour
  DataCount=3 ' 3 (+1) data Points
  CostPerkWHr=8.7

  open "projects\MyVisibleEnergy_project\MyIPs.txt" for input as #1
  x=0
  while eof(#1)=0
    line input #1,item$
    x=x+1
  wend
  close #1
  lastIP=x
  if lastIP<1 then print "No IP file found" : end
  dim IP$(lastIP+1)
  dim Status$(lastIP+1,7)
  dim Name$(lastIP+1)
  dim Socket$(lastIP+1,7*10)
  dim Energy$(4,31)
  dim DataItem(31)
  open "projects\MyVisibleEnergy_project\MyIPs.txt" for input as #1
  x=1
  while eof(#1)=0
    line input #1, IP$(x)
    rem print IP$(x)
    x=x+1
  wend
  close #1
  for Selected=1 to lastIP
    rem print "Selected:";Selected
    gosub [GetStatus]
    Status$(Selected,0)=MAC$
    Status$(Selected,1)=UTC$
    Status$(Selected,2)=release$
    Status$(Selected,3)=model$
    Status$(Selected,4)=name$
    Status$(Selected,5)=str$(socket-1)
    rem print "Socket:";socket-1
    Name$(Selected)=name$
    rem gosub [ShowResults]
  next Selected
  Selected=1
  Selected$=Status$(Selected,4)
  goto [SwitchClicked]

[ShowResults]
  for x=0 to val(Status$(Selected,5))  
    print "Device ";Selected
    print "Socket ";x
    print "Name ";Socket$(Selected,x*10)
    print "State ";Socket$(Selected,x*10+1)
    print "Watts ";Socket$(Selected,x*10+2)
    print "Peak ";Socket$(Selected,x*10+3)
    print "Type ";Socket$(Selected,x*10+4)
    print "Total ";Socket$(Selected,x*10+5)
    print "OneshotTotal ";Socket$(Selected,x*10+6)
  next x
  input x
  return

[GetStatus]
  on error goto [httpGetError]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/status.js"
  rem url$
  response$=httpget$(url$)
  print response$
  StartPosition=0
  JSONItem$="mac"
  gosub [GetJSON]
  MAC$=JSONValue$
  JSONItem$="utc"
  gosub [GetJSON]
  UTC$=JSONValue$
  JSONItem$="release"
  gosub [GetJSON]
  release$=JSONValue$
  JSONItem$="model"
  gosub [GetJSON]
  model$=JSONValue$
  JSONItem$="name"
  gosub [GetJSON]
  name$=JSONValue$
  socket=0

[StatusSocketLoop]
  JSONItem$="position"
  gosub [GetJSON] 
  if JSONValue$<>"" then
    JSONItem$="name"
    Gosub [GetJSON]
    Socket$(Selected,socket*10)=JSONValue$
    JSONItem$="state"
    Gosub [GetJSON]
    Socket$(Selected,socket*10+1)=JSONValue$
    JSONItem$="watts"
    Gosub [GetJSON]
    Socket$(Selected,socket*10+2)=JSONValue$
    JSONItem$="peak"
    Gosub [GetJSON]
    Socket$(Selected,socket*10+3)=JSONValue$
    JSONItem$="type"
    gosub [GetJSON]
    Socket$(Selected,socket*10+4)=JSONValue$
    JSONItem$="total"
    gosub [GetJSON]
    Socket$(Selected,socket*10+5)=JSONValue$
  rem get timers
    JSONItem$="oneshottotal"
    gosub [GetJSON]
    Socket$(Selected,socket*10+6)=JSONValue$
  rem get one-shots
    socket=socket+1
    rem print "Socket:";socket
    goto [StatusSocketLoop]
  end if
  return

[httpGetError]
  Print "Error:";Err$
  input x
  return

[GetJSON]
  StartPosition = instr(response$,JSONItem$,StartPosition)
  if StartPosition<>0 then 
    StartPosition=StartPosition+len(JSONItem$)+2
    while mid$(response$,StartPosition,1)=" " ' get rid of white space
      StartPosition=StartPosition+1
    wend
    rem print "Next char=";mid$(response$,StartPosition,1);" at location=";StartPosition
    select case mid$(response$,StartPosition,1)
      case chr$(34) ' quote
        EndPosition=instr(response$,chr$(34),StartPosition+1)
        JSONValue$=mid$(response$,StartPosition+1, EndPosition-StartPosition-1)
        JSONStatus$="Value"
        StartPosition=EndPosition
      case "{"
        BracePosition=StartPosition
        [JSONBraceClose]
          EndPosition=instr(response$,"}",StartPosition+1)
          gosub [JSONCheck4Brace]
          if TestPosition<>0 then
            rem print "Brace Found at:";TestPosition
            if TestPosition<EndPosition then
              StartPosition=EndPosition
              goto [JSONBraceClose]
            end if
          end if
          gosub [JSONCheck4Bracket]
          if TestPosition<>0 then
            rem print "Bracket Found at:";TestPosition
            if TestPosition<EndPosition then
              StartPosition=EndPosition
              goto [JSONBraceClose]
            end if
          end if
          JSONValue$=mid$(response$,BracePosition,EndPosition-BracePosition+1)
          JSONStatus$="List"
      case "["
        BracketPosition=StartPosition
        [JSONBracketClose]
          EndPosition=instr(response$,"]",StartPosition+1)
          gosub [JSONCheck4Brace]
          if TestPosition<>0 then
            rem print "Brace Found at:";TestPosition
            if TestPosition<EndPosition then
              StartPosition=EndPosition
              goto [JSONBracketClose]
            end if
          end if
          gosub [JSONCheck4Bracket]
          if TestPosition<>0 then
            rem print "Bracket Found at:";TestPosition
            if TestPosition<EndPosition then
              StartPosition=EndPosition
              goto [JSONBracketClose]
            end if
          end if
          JSONValue$=mid$(response$,BracketPosition,EndPosition-BracketPosition+1)
          JSONStatus$="Array"
      case else
        if ((mid$(response$,StartPosition,1)>chr$(47)) and (mid$(response$,StartPosition,1)<chr$(58))) then ' numeric
          JSONStatus$="Value"
          EndPosition=instr(response$,chr$(44),StartPosition+1) ' comma
          JSONValue$=mid$(response$,StartPosition, EndPosition-StartPosition)
          StartPosition=EndPosition
        else
         JSONStatus$="Not Found"
         JSONValue$=""
        end if
    end select
  else
    JSONStatus$="Not Found"
    JSONValue$=""
  end if

  rem print "Status=";JSONStatus$;" ";JSONItem$;"=";JSONValue$

  return

[JSONCheck4Brace]
  TestPosition=instr(response$,"{",StartPosition)
  if TestPosition<>0 then
    TestPosition=instr(response$,"}",TestPosition)
  end if
  return

[JSONCheck4Bracket]
  TestPosition=instr(response$,"[",StartPosition)
  if TestPosition<>0 then
    TestPosition=instr(response$,"]",TestPosition)
  end if
  return

'[GetFrame]
  position1 = instr(response$,"<";FrameItem$;">")
  if position1<>0 then 
    position2 = instr(response$,"<";"/";FrameItem$;">",position1+len(FrameItem$)+2)
    if position2<>0 then
      FrameValue$=mid$(response$,position1+len(FrameItem$)+2,position2-position1-len(FrameItem$)-2)
      rem print FrameValue$
    else
      FrameValue$=""
    end if
  else
    FrameValue$=""
  end if
  return

[EnergyClicked]
  cls
  Mode=0

  gosub [HighlightIP]

  gosub [HighlightMode]

  rem textarea #URLResponse, response$, 50, 10

  gosub [HighLightPeriod] 

  gosub [GetEnergy]
 
  gosub [DisplayEnergy]

  wait

[PowerClicked]
  cls
  Mode=1

  gosub [HighlightIP]

  gosub [HighlightMode]

  rem textarea #URLResponse, response$, 50, 10

  gosub [HighlightPower]

  wait

[CostClicked]
  cls
  Mode=2

  gosub [HighlightIP]

  gosub [HighlightMode]

  rem textarea #URLResponse, response$, 50, 10

  gosub [HighlightCost]

  wait

[SwitchClicked]
  cls
  Mode=3

  gosub [HighlightIP]

  gosub [HighlightMode]

  rem textarea #URLResponse, response$, 50, 10

  gosub [HighlightSwitch]

  wait


[SettingsClicked]
  cls
  Mode=4

  gosub [HighlightIP]

  gosub [HighlightMode]

  rem textarea #URLResponse, response$, 50, 10

  gosub [HighlightCostOfEnergy]
 
  wait

[accept]
  Selected$=#Name SELECTION$()
  for x=1 to lastIP
    if Status$(x,4)=Selected$ then Selected=x
  next x
  goto [Continue]

[Continue]
  gosub [GetStatus]
  select case Mode
    case 0
      goto [EnergyClicked]
    case 1
      goto [PowerClicked]
    case 2
      goto [CostClicked]
    case 3
      goto [SwitchClicked]
    case 4
      goto [SettingsClicked]
  end select
  wait

[ChangeCostClicked]
  input CostPerkWHr
  if CostPerkWHr>99.9 then CostPerkWHr=99.9 
  if CostPerkWHr<0 then CostPerkWHr=0
  goto [SettingsClicked]


[SocketStateOFF0Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/0/set.xml?value=off"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[SocketStateON0Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/0/set.xml?value=on"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[SocketStateOFF1Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/1/set.xml?value=off"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[SocketStateON1Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/1/set.xml?value=on"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[SocketStateOFF2Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/2/set.xml?value=off"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[SocketStateON2Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/2/set.xml?value=on"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[SocketStateOFF3Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/3/set.xml?value=off"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[SocketStateON3Clicked]
  rem print IP$(Selected)
  url$="http://";IP$(Selected);"/3/set.xml?value=on"
  rem print url$
  response$=httpget$(url$)
  rem print response$
  goto [Continue]

[HighlightIP]
  LISTBOX #Name, Name$(), 1
  #Name SELECT(Selected$)
  print " ";
  button #Accept, "Select", [accept]
  print
  return

[HighlightMode]
  button #Energy, "Energy", [EnergyClicked]
  #Energy CSSClass("lightgrayButton")

  button #Power, "Power", [PowerClicked]
  #Power CSSClass("lightgrayButton")

  button #Cost, "Cost", [CostClicked]
  #Cost CSSClass("lightgrayButton")

  button #Switch, "Switch", [SwitchClicked]
  #Switch CSSClass("lightgrayButton")

  button #Settings, "Settings", [SettingsClicked]
  #Settings CSSClass("lightgrayButton")

  select case Mode
    case 0
      #Energy CSSClass("blueButton")
    case 1
      #Power CSSClass("redButton")
    case 2
      #Cost CSSClass("yellowButton")
    case 3
      #Switch CSSClass("greenButton")
    case 4
      #Settings CSSClass("purpleButton")

  end select

  print
  return

[HighLightPeriod]
  button #Hour, "Hour (15m)", [HourClicked]
  #Hour CSSClass("lightgrayButton")

  button #Day, "Day (Hr)", [DayClicked]
  #Day CSSClass("lightgrayButton")

  button #Week, "Week (day)", [WeekClicked]
  #Week CSSClass("lightgrayButton")

  button #Month, "Month (day)", [MonthClicked]
  #Month CSSClass("lightgrayButton")

  select case Period
    case 0
      #Hour CSSClass("purpleButton")
    case 1
      #Day CSSClass("purpleButton")
    case 2
      #Week CSSClass("purpleButton")
    case 3
      #Month CSSClass("purpleButton")
  end select

  print

  return

[HighlightPower]
  for socket=0 to val(Status$(Selected,5))
    select case socket
      case 0    
        FillColor$="orange"
        gosub [DisplayPower]
      case 1
        FillColor$="red"
        gosub [DisplayPower]
      case 2
        FillColor$="yellow"
        gosub [DisplayPower]
      case 3
        FillColor$="blue"
        gosub [DisplayPower]
    end select
  next socket

  return

[DisplayPower]
  Power=int(val(Socket$(Selected,socket*10+2)))
  Peak=int(val(Socket$(Selected,socket*10+3)))
  ChartLimit=1
  while ChartLimit<Peak
    ChartLimit=ChartLimit*10
  wend
  graphic #Power, 230, 50
  #Power fill(FillColor$)
  #Power color("black")
  title$ = "0                                           ";ChartLimit
  #Power place(10, 15)
  #Power "\";title$
  for x=10 to 211 step 5
    #Power line(x,20,x,30)
  next x

  #Power color("white")
  for x = 10 to Peak*201/ChartLimit+10
    #Power line(x,20,x,30)   
  next x

  #Power color("black")
  for x = 10 to Power*201/ChartLimit+10
    #Power line(x,20,x,30)   
  next x

  #Power color("black")
  title$ = Socket$(Selected,socket*10+0);": ";Socket$(Selected,socket*10+2);"w ";Socket$(Selected,socket*10+3);"pk"
  #Power place(10, 45)
  #Power "\";title$
  render #Power
  print

  return

[HighlightCost]
  print "C o s t   o f   e n e r g y"
  print
  for x=0 to val(Status$(Selected,5))
    graphic #cost, 250, 40
    select case x
      case 0
        #cost fill("orange")
      case 1
        #cost fill("red")
      case 2
        #cost fill("yellow")
      case 3
        #cost fill("blue")
    end select
    #cost size(10)
    Cost=CostPerkWHr*val(Socket$(Selected,x*10+2))
    title$ = using("#.###", Cost/1000);" cents"
    #cost FONT("NewTimesRoman", 30)
    xPosition = (#cost width() - #cost stringwidth(title$)) / 2
    #cost place(xPosition, 35)
    #cost "\";title$
    render #cost
    print
  next x

  return

[HighlightSwitch]
  for x=0 to val(Status$(Selected,5))
    select case x
      case 0
        textbox #SocketName0, Socket$(Selected,x*10)
        button #SocketStateON0, "On", [SocketStateON0Clicked]
        button #SocketStateOFF0, "Off", [SocketStateOFF0Clicked]
        print
        if Socket$(Selected,x*10+1)="ON" then
          #SocketStateON0 CSSClass("orangeButton")
          #SocketStateOFF0 CSSClass("lightgrayButton")
        else
          #SocketStateON0 CSSClass("lightgrayButton")
          #SocketStateOFF0 CSSClass("orangeButton")
        end if
      case 1
        textbox #SocketName1, Socket$(Selected,x*10)
        button #SocketStateON1, "On", [SocketStateON1Clicked]
        button #SocketStateOFF1, "Off", [SocketStateOFF1Clicked]
        print
        if Socket$(Selected,x*10+1)="ON" then
          #SocketStateON1 CSSClass("redButton")
          #SocketStateOFF1 CSSClass("lightgrayButton")
        else
          #SocketStateON1 CSSClass("lightgrayButton")
          #SocketStateOFF1 CSSClass("redButton")
        end if
      case 2
        textbox #SocketName2, Socket$(Selected,x*10)
        button #SocketStateON2, "On", [SocketStateON2Clicked]
        button #SocketStateOFF2, "Off", [SocketStateOFF2Clicked]
        print
        if Socket$(Selected,x*10+1)="ON" then
          #SocketStateON2 CSSClass("yellowButton")
          #SocketStateOFF2 CSSClass("lightgrayButton")
        else
          #SocketStateON2 CSSClass("lightgrayButton")
          #SocketStateOFF2 CSSClass("yellowButton")
        end if
      case 3
        textbox #SocketName3, Socket$(Selected,x*10)
        button #SocketStateON3, "On", [SocketStateON3Clicked]
        button #SocketStateOFF3, "Off", [SocketStateOFF3Clicked]
        print
        if Socket$(Selected,x*10+1)="ON" then
          #SocketStateON3 CSSClass("blueButton")
          #SocketStateOFF3 CSSClass("lightgrayButton")
        else
          #SocketStateON3 CSSClass("lightgrayButton")
          #SocketStateOFF3 CSSClass("blueButton")
        end if 
    end select
  next x

  return

[HighlightCostOfEnergy]

  print "C o s t   o f   e n e r g y / k W H r"
  print
  graphic #cost, 200, 40
  #cost fill("yellow")
  #cost size(10)
  title$ = str$(CostPerkWHr);" cents"
  #cost FONT("NewTimesRoman", 30)
  xPosition = (#cost width() - #cost stringwidth(title$)) / 2
  #cost place(xPosition, 35)
  #cost "\";title$
  render #cost

  print
  button #ChangeCost, "Change Cost/kWHr", [ChangeCostClicked]
  #ChangeCost CSSClass("lightgrayButton")
  print

  return

[HourClicked]
  Period=0
  DataCount=3
  goto [EnergyClicked]

[DayClicked]
  Period=1
  DataCount=23
  goto [EnergyClicked]

[WeekClicked]
  Period=2
  DataCount=6
  goto [EnergyClicked]

[MonthClicked]
  Period=3
  DataCount=30
  goto [EnergyClicked]

[GetEnergy]
  select case Period
    case 0
      Period$="hour"
    case 1
      Period$="day"
    case 2
      Period$="week"
    case 3
      Period$="month"
  end select
  url$="http://";IP$(Selected);"/energy.js?period=";Period$
  response$=httpget$(url$)

  for Socket=0 to val(Status$(Selected,5))
    JSONItem$="energy"
    gosub [GetJSON]
    ArrayStartPosition=1
    for DataItem=0 to DataCount
      ArrayEndPosition=instr(JSONValue$,",",ArrayStartPosition+1)
      if ArrayEndPosition<>0 then
        Energy$(Socket,DataItem)=mid$(JSONValue$,ArrayStartPosition+1,ArrayEndPosition-ArrayStartPosition-1)
        ArrayStartPosition=ArrayEndPosition
        rem print Energy$(Socket,DataItem)
      else   
        ArrayEndPosition=instr(JSONValue$,"]",ArrayStartPosition+1)
        Energy$(Socket,DataItem)=mid$(JSONValue$,ArrayStartPosition+1,ArrayEndPosition-ArrayStartPosition-1)
        ArrayStartPosition=ArrayEndPosition
        rem print Energy$(Socket,DataItem)
      end if
    next DataItem
    StartPosition=EndPosition
  next Socket
  return

[GetMaxEnergy]
  MaxEnergy=0
  ChartLimit=1
  for x=0 to DataCount
    MaxEnergy=max(MaxEnergy,val(Energy$(Socket,x)))
    DataItem(x)=val(Energy$(Socket,x))
  next x
  while ChartLimit<MaxEnergy
    ChartLimit=ChartLimit*10
  wend
  return

[DisplayEnergy]
  select case Period
    case 0
      gosub [DisplayHour]
    case 1
      gosub [DisplayDay]
    case 2
      gosub [DisplayWeek]
    case 3
      gosub [DisplayMonth]
  end select
  return

[DisplayHour]
 for Socket=0 to val(Status$(Selected,5))
    select case Socket
      case 0
        FillColor$="orange"
      case 1
        FillColor$="red"
      case 2
        FillColor$="yellow"
      case 3
        FillColor$="blue"
    end select

    graphic #Energy, 280, 230
    #Energy fill(FillColor$)
    #Energy color("white")
    for x=60 to 260 step 50 '4 data points
      #Energy line(x,10,x,210)
    next x
    for y=10 to 210 step 20
      #Energy line(60,y,260,y)
    next y
    #Energy color("black")
    title$ = "-60min  -45min  -30min  -15min  Now"
    #Energy place(50, 225)
    #Energy "\";title$
    gosub [GetMaxEnergy]
    title$ = "0"
    #Energy place(5, 215)
    #Energy "\";title$
    title$ = str$(ChartLimit)
    #Energy place(5, 15)
    #Energy "\";title$      
    lasty=210
    for x=0 to DataCount
      #Energy line(x*50+60,lasty,x*50+60,int((ChartLimit-DataItem(x))*200/ChartLimit+10))
      lasty=int((ChartLimit-DataItem(x))*200/ChartLimit+10)
      #Energy line(x*50+60,lasty,x*50+110,lasty)
    next x
    render #Energy
    print
  next Socket
  return

[DisplayDay]
 for Socket=0 to val(Status$(Selected,5))
    select case Socket
      case 0
        FillColor$="orange"
      case 1
        FillColor$="red"
      case 2
        FillColor$="yellow"
      case 3
        FillColor$="blue"
    end select

    graphic #Energy, 280, 230
    #Energy fill(FillColor$)
    #Energy color("white")
    for x=60 to 252 step 48 '24 data points
      #Energy line(x,10,x,210)
    next x
    for y=10 to 210 step 20
      #Energy line(60,y,252,y)
    next y
    #Energy color("black")
    title$ = "-24hr   -18hr   -12hr    -6hr     Now"
    #Energy place(50, 225)
    #Energy "\";title$
    gosub [GetMaxEnergy]
    title$ = "0"
    #Energy place(5, 215)
    #Energy "\";title$
    title$ = str$(ChartLimit)
    #Energy place(5, 15)
    #Energy "\";title$
    lasty=210
    for x=0 to DataCount
      #Energy line(x*8+60,lasty,x*8+60,int((ChartLimit-DataItem(x))*200/ChartLimit+10))
      lasty=int((ChartLimit-DataItem(x))*200/ChartLimit+10)
      #Energy line(x*8+60,lasty,x*8+68,lasty)
    next x
    render #Energy
    print
  next Socket
  return

[DisplayWeek]
 for Socket=0 to val(Status$(Selected,5))
    select case Socket
      case 0
        FillColor$="orange"
      case 1
        FillColor$="red"
      case 2
        FillColor$="yellow"
      case 3
        FillColor$="blue"
    end select

    graphic #Energy, 280, 230
    #Energy fill(FillColor$)
    #Energy color("white")
    for x=60 to 270 step 30 '7 data points
      #Energy line(x,10,x,210)
    next x
    for y=10 to 210 step 20
      #Energy line(60,y,270,y)
    next y
    #Energy color("black")
    title$ = "-7days    -5days    -3days    -1day Now"
    #Energy place(50, 225)
    #Energy "\";title$
    gosub [GetMaxEnergy]
    title$ = "0"
    #Energy place(5, 215)
    #Energy "\";title$
    title$ = str$(ChartLimit)
    #Energy place(5, 15)
    #Energy "\";title$
    lasty=210
    for x=0 to DataCount
      #Energy line(x*30+60,lasty,x*30+60,int((ChartLimit-DataItem(x))*200/ChartLimit+10))
      lasty=int((ChartLimit-DataItem(x))*200/ChartLimit+10)
      #Energy line(x*30+60,lasty,x*30+90,lasty)
    next x
    render #Energy
    print
  next Socket
  return

[DisplayMonth]
 for Socket=0 to val(Status$(Selected,5))
    select case Socket
      case 0
        FillColor$="orange"
      case 1
        FillColor$="red"
      case 2
        FillColor$="yellow"
      case 3
        FillColor$="blue"
    end select

    graphic #Energy, 280, 230
    #Energy fill(FillColor$)
    #Energy color("white")
    for x=60 to 246 step 6 '31 data points
      #Energy line(x,10,x,210)
    next x
    for y=10 to 210 step 20
      #Energy line(60,y,246,y)
    next y
    #Energy color("black")
    title$ = "-31days   -20days   -10days      Now"
    #Energy place(50, 225)
    #Energy "\";title$
    gosub [GetMaxEnergy]
    title$ = "0"
    #Energy place(5, 215)
    #Energy "\";title$
    title$ = str$(ChartLimit)
    #Energy place(5, 15)
    #Energy "\";title$
    lasty=210
    for x=0 to DataCount
      #Energy line(x*6+60,lasty,x*6+60,int((ChartLimit-DataItem(x))*200/ChartLimit+10))
      lasty=int((ChartLimit-DataItem(x))*200/ChartLimit+10)
      #Energy line(x*6+60,lasty,x*6+66,lasty)
    next x
    render #Energy
    print
  next Socket

  return